> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Authenticate

> Authenticate with password using the Stytch Next.js SDK

The Authenticate method wraps the [Authenticate](https://stytch.com/docs/api-reference/consumer/api/passwords/authenticate.md) Password API endpoint. This endpoint verifies that the user has a password currently set, and that the entered password is correct. There are cases where this endpoint will return a `reset_password` error even if the password entered is correct. View our [API Docs](https://stytch.com/docs/api-reference/consumer/api/passwords/authenticate.md) for more information.

If this method succeeds, the user will be logged in, granted an active session, and the [session cookies](https://stytch.com/docs/api-reference/consumer/frontend-sdks/react/resources/cookies-and-session-management.md) will be minted and stored in the browser.

## Parameters

**email** `string` *required*

The email of the user.

**password** `string` *required*

The password for the user. Any UTF8 character is allowed, e.g. spaces, emojis, non-English characters, etc.

**session\_duration\_minutes** `int` *required*

Set the session lifetime to be this many minutes from now. This will return both an opaque session\_token and session\_jwt for this session, which will automatically be stored either in the browser cookies if you're using our JavaScript SDK, or in the iOS Keychain/ Android SharedPreferences if you're using one of our mobile SDKs. The `session_jwt` will have a fixed lifetime of five minutes regardless of the underlying session duration, and will be automatically refreshed by the SDK in the background over time. This value must be a minimum of 5 and may not exceed the maximum session duration minutes value set in the [Frontend SDK page](https://stytch.com/dashboard/sdk-configuration) of the Stytch Dashboard. A successful authentication will continue to extend the session this many minutes.

## Response

**user\_id** `string`

The unique ID of the affected User.

**user** `object`

The user object affected by call.  See the [User object](https://stytch.com/docs/api-reference/consumer/api/users/user-object.md) for complete response field details.

**properties**

**created\_at** `string`

The timestamp of the User's creation. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**crypto\_wallets** `array[objects]`

An array contains a list of all crypto wallets for a given User in the Stytch API.

**properties**

**crypto\_wallet\_id** `string`

The unique ID for a crypto wallet

**crypto\_wallet\_address** `string`

The actual blockchain address of the User's crypto wallet.

**crypto\_wallet\_type** `string`

The blockchain that the User's crypto wallet operates on, e.g. Ethereum, Solana, etc.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**emails** `array[objects]`

An array of email objects for the User.

**properties**

**email\_id** `string`

The unique ID of a specific email address.

**email** `string`

The email address.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**name** `object`

The name of the User. Each field in the name object is optional.

**properties**

**first\_name** `string`

The first name of the user.

**middle\_name** `string`

The middle name(s) of the user.

**last\_name** `string`

The last name of the user.

**trusted\_metadata** `object`

The trusted\_metadata field contains an arbitrary JSON object of application-specific data. See the [Metadata](https://stytch.com/docs/api-reference/consumer/api/resources/metadata.md) reference for complete field behavior details.

**untrusted\_metadata** `object`

The untrusted\_metadata field contains an arbitrary JSON object of application-specific data. Untrusted metadata can be edited by end users directly via the SDK, and **cannot be used to store critical information.** See the [Metadata](https://stytch.com/docs/api-reference/consumer/api/resources/metadata.md) reference for complete field behavior details.

**phone\_numbers** `array[objects]`

An array of phone number objects linked to the User.

**properties**

**phone\_id** `string`

The unique ID for the phone number.

**phone\_number** `string`

The phone number.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**providers** `array[objects]`

An array of OAuth provider objects linked to the User.

**properties**

**oauth\_user\_registration\_id** `string`

The unique ID for an OAuth registration.

**provider\_subject** `string`

The unique identifier for the User within a given OAuth provider. Also commonly called the "sub" or "Subject field" in OAuth protocols.

**provider\_type** `string`

Denotes the OAuth identity provider that the user has authenticated with, e.g. Google, Facebook, GitHub etc.

**profile\_picture\_url** `string`

If available, the profile\_picture\_url is a url of the User's profile picture set in OAuth identity the provider that the User has authenticated with, e.g. Facebook profile picture.

**locale** `string`

If available, the locale is the User's locale set in the OAuth identity provider that the user has authenticated with.

**password** `object`

The password object is returned for users with a password.

**properties**

**password\_id** `string`

The unique ID of a specific password

**requires\_reset** `boolean`

Indicates whether this password requires a password reset

**status** `string`

The status of the User. The possible values are `pending` and `active`.

**totps** `array[objects]`

An array containing a list of all TOTP instances for a given User in the Stytch API.

**properties**

**totp\_id** `string`

The unique ID for a TOTP instance.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**user\_id** `string`

The unique ID of the affected User.

**webauthn\_registrations** `array[objects]`

An array that contains a list of all Passkey or WebAuthn registrations for a given User in the Stytch API.

**properties**

**webauthn\_registration\_id** `string`

The unique ID for the Passkey or WebAuthn registration.

**domain** `string`

The domain on which Passkey or WebAuthn registration was started. This will be the domain of your app.

**user\_agent** `string`

The user agent of the User.

**authenticator\_type** `string`

The authenticator\_type string displays the requested authenticator type of the Passkey or WebAuthn device. The two valid types are "platform" and "cross-platform". If no value is present, the Passkey or WebAuthn device was created without an authenticator type preference.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**name** `string`

The name of the Passkey or WebAuthn registration.

**biometric\_registrations** `array[objects]`

An array that contains a list of all biometric registrations for a given User in the Stytch API.

**properties**

**biometric\_registration\_id** `string`

The unique ID for a biometric registration.

**verified** `boolean`

If this method has been successfully authenticated by the User.

**roles** `array[strings]`

Roles assigned to this User. See the [RBAC guide](https://stytch.com/docs/consumer-auth/authorization/assigning-roles-to-users.md) for more information about role assignment.

**session\_token** `string`

A secret token for a given Stytch Session.

**session\_jwt** `string`

The JSON Web Token (JWT) for a given Stytch Session.

**session** `object`

If you initiate a Session, by including session\_duration\_minutes in your authenticate call, you'll receive a full Session object in the response. See [Session object](https://stytch.com/docs/api-reference/consumer/api/sessions/session-object.md) for complete response fields.

**properties**

**session\_id** `string`

A unique identifier for a specific Session.

**user\_id** `string`

The unique ID of the affected User.

**authentication\_factors** `array[objects]`

An array of different authentication factors that comprise a Session.

**started\_at** `string`

The timestamp when the Session was created. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**last\_accessed\_at** `string`

The timestamp when the Session was last accessed. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**expires\_at** `string`

The timestamp when the Session expires. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**attributes** `object`

Provided attributes help with fraud detection.

**properties**

**ip\_address** `string`

The IP address of the user.

**user\_agent** `string`

The user agent of the User.

**custom\_claims** `map`

The custom claims map for a Session. Claims can be added to a session during a Sessions authenticate call.

**roles** `array[string]`

A list of the roles associated with the session.

**user\_device** `object`

If [Protected Auth](https://stytch.com/docs/fraud-risk/device-fingerprinting/protected-auth.md) is enabled and returned fingerprinting results, the user\_device response field will contain information about the user's device attributes.

**properties**

**ip\_address** `string`

The IP address of the user's device.

**ip\_address\_details** `object`

Information about the ip\_address.

**properties**

**is\_new** `boolean`

Whether this ip\_address has been seen before for this user.

**first\_seen\_at** `string`

When this ip\_address was first seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**last\_seen\_at** `string`

When this ip\_address was last seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**ip\_geo\_country** `string`

The country code where the IP address is located.

**ip\_geo\_country\_details** `object`

Information about the ip\_geo\_country.

**properties**

**is\_new** `boolean`

Whether this ip\_geo\_country has been seen before for this user.

**first\_seen\_at** `string`

When this ip\_geo\_country was first seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**last\_seen\_at** `string`

When this ip\_geo\_country was last seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.

**ip\_geo\_city** `string`

The city where the IP address is located.

**ip\_geo\_region** `string`

The region where the IP address is located.

**request\_id** `string`

Globally unique UUID that is returned with every API call. This value is important to log for debugging purposes; we
may ask for this value to help identify a specific API call when helping you debug an issue.

**status\_code** `number`

The HTTP status code of the response. Stytch follows standard HTTP response status code patterns, e.g. 2XX values
equate to success, 3XX values are redirects, 4XX are client errors, and 5XX are server errors.

```jsx theme={null}
import { useCallback } from 'react';
import { useStytch } from '@stytch/nextjs';

export const Login = () => {
const stytch = useStytch();

const authenticatePassword = useCallback(() => {
  stytch.passwords.authenticate({
    email: '${exampleEmail}',
    password: '${examplePassword}',
    session_duration_minutes: 60,
  });
}, [stytch]);

return <button onClick={authenticatePassword}>Authenticate Password</button>;
};
```

```json 200 theme={null}
{
    "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
    "session": null,
    "session_jwt": "",
    "session_token": "",
    "status_code": 200,
    "user": {...},
    "user_id": "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
}
```

```json 401 theme={null}
{
  "status_code": 401,
  "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
  "error_type": "unauthorized_credentials",
  "error_message": "Unauthorized credentials.",
  "error_url": "https://stytch.com/docs/api/errors/401"
}
```

```json 404 theme={null}
{
  "status_code": 404,
  "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
  "error_type": "email_not_found",
  "error_message": "Email could not be found.",
  "error_url": "https://stytch.com/docs/api/errors/404"
}
```

```json 429 theme={null}
{
  "status_code": 429,
  "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
  "error_type": "too_many_requests",
  "error_message": "Too many requests have been made.",
  "error_url": "https://stytch.com/docs/api/errors/429"
}
```

```json 500 theme={null}
{
  "status_code": 500,
  "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
  "error_type": "internal_server_error",
  "error_message": "Oops, something seems to have gone wrong, please reach out to support@stytch.com to let us know what went wrong.",
  "error_url": "https://stytch.com/docs/api/errors/500"
}
```
